//  (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// Disk 1
	struct fpos md1[] =
	{
		{ 0x2c, 0x09, 0x00, 0x0400 }, //
		{ 0x2c, 0x0d, 0x00, 0x0500 }, //
		{ 0x2d, 0x02, 0x00, 0x0500 }, //
		{ 0x2d, 0x07, 0x00, 0x0400 }, //
		{ 0x2d, 0x0b, 0x00, 0x0200 }, //
		{ 0x2d, 0x0d, 0x00, 0x0400 }, //
		{ 0x00, 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 2
	struct fpos md2[] =
	{
		{ 0x01, 0x09, 0x00, 0x0500 }, // 
		{ 0x01, 0x0e, 0x00, 0x0300 }, // 
		{ 0x2c, 0x09, 0x00, 0x0700 }, // 
		{ 0x2c, 0x10, 0x00, 0x0400 }, // 
		{ 0x2d, 0x0c, 0x00, 0x0200 }, // 
		{ 0x43, 0x01, 0x00, 0x0a00 }, // 
		{ 0x3f, 0x02, 0xfc, 0x0640 }, // 
		{ 0x00, 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		switch (buff[0x40])
		{
		case 0x20:
			printf("Disk 1 F܂.\n");
			fcut("PROG", 0x00, 0x00, 0x00, 0x05, 0x01, 0x0000, 0x3f00);
			for (i=0; md1[i].sec; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, md1[i].ofs, md1[i].size);
			}
			continue;

		case 0xc0:
			printf("Disk 2 F܂.\n");
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, md2[i].ofs, md2[i].size);
			}
			continue;
		}
	}
	return 0;
}

